VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTypeLibraryInfoProvider"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
' -----------------------------------------------------------------
' Copyright by Philip Sakellaropoulos - KNOWLEDGE, 2000-2001
' -----------------------------------------------------------------
Option Explicit
Dim m_tli As TypeLibInfo
Dim m_fso As FileSystemObject
Private mvarXMLFile As String 'XML file
Dim m_oldDom As DOMDocument30  ' existing XML doc
Dim m_dom As DOMDocument30  ' new XML doc
Dim m_templateDom As DOMDocument30  ' template doc
Private mvarBaseDir As String 'base directory
Private mvarEncoding As String 'ISO encoding string
'local variable(s) to hold property value(s)
Private mvarOutputFiles As Collection 'local copy
Private mvarOutputFileTypes As Collection 'local copy
Private sTypeLibraryFile As String
Private sModuleName As String ' module name (typelibraryfile without extension)
Public Overwrite As Boolean
Public CompanyLogo As String
Public CompanyHref As String
'"OutputDirectory", "TypeLibrary", "XMLDescription", _
' "HelpProject", "HelpContent", "HelpIndex", "XSLFilesTemplate")

Public Property Set OutputFiles(ByVal vData As Collection)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.OutputFiles = Form1
    Set mvarOutputFiles = vData
End Property
Public Property Get OutputFiles() As Collection
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.OutputFiles
    Set OutputFiles = mvarOutputFiles
End Property
Public Property Set OutputFileTypes(ByVal vData As Collection)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.OutputFiles = Form1
    Set mvarOutputFileTypes = vData
End Property
Public Property Get OutputFileTypes() As Collection
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.OutputFiles
    Set OutputFileTypes = mvarOutputFileTypes
End Property

Private Sub Class_Initialize()
  Set m_tli = New TypeLibInfo
  Set m_oldDom = New DOMDocument
  Set m_templateDom = New DOMDocument
  Set m_dom = New DOMDocument
  Set m_fso = New FileSystemObject
End Sub
Private Sub Class_Terminate()
 Set TLIApplication = Nothing
 Set m_tli = Nothing
End Sub
Public Property Let Encoding(ByVal vData As String)
    mvarEncoding = vData
End Property
Public Property Get Encoding() As String
    Encoding = mvarEncoding
End Property
Public Property Let BaseDir(ByVal vData As String)
    mvarBaseDir = vData
End Property
Public Property Get BaseDir() As String
    BaseDir = mvarBaseDir
End Property
Public Property Let XMLFile(ByVal vData As String)
  mvarXMLFile = vData
End Property
Public Property Get XMLFile() As String
    XMLFile = mvarXMLFile
End Property
' a huge routine to create XML file from data found in TLB
' descriptions for existing routines and parameters are copied
' TypeLibraryInfo and XML technologies are utilizied
Public Function WriteTLBdata2XMLfile() As Boolean
Dim sXML As String, sXMLCopy As String
Dim nCoClasses As IXMLDOMElement, nInterfaces As IXMLDOMElement
Dim nMembers As IXMLDOMElement, nParameters As IXMLDOMElement
Dim nCoClassT As IXMLDOMElement, nInterfaceT As IXMLDOMElement
Dim nMemberT As IXMLDOMElement, nParameterT As IXMLDOMElement
Dim nEnumerations As IXMLDOMElement, nEnumMembers As IXMLDOMElement
Dim nEnumerationT As IXMLDOMElement, nEnumMemberT As IXMLDOMElement
Dim nDe As IXMLDOMElement, nDeT As IXMLDOMElement, nItem As IXMLDOMElement
Dim nDeOld As IXMLDOMElement, nItemOld As IXMLDOMElement
Dim nDesc As IXMLDOMElement, nDescOld As IXMLDOMElement
Dim nRetDesc As IXMLDOMElement, nRetDescOld As IXMLDOMElement
Dim nExample As IXMLDOMElement, nExampleOld As IXMLDOMElement
Dim nSeeAlso As IXMLDOMElement, nSeeAlsoOld As IXMLDOMElement
Dim nParamDesc As IXMLDOMElement, nParamDescOld As IXMLDOMElement
Dim nMemberAttr As IXMLDOMNode, nMemberAttrOld As IXMLDOMNode
Dim sPathCoclass As String, sPathInterface As String
Dim sPathMember As String, sPathParameter As String
Dim pi As IXMLDOMProcessingInstruction
Dim cofo As CoClassInfo, confo As ConstantInfo
Dim ifo As InterfaceInfo, ivfo As InterfaceInfo, ibasefo As InterfaceInfo
Dim Bases As TypeInfos ' base interfaces
Dim MI As MemberInfo, sdata As Long, bExisting As Boolean
Dim SR As SearchResults, SI As SearchItem, InvKinds As InvokeKinds
Dim s As String ' string for debugging
Dim AttrArray() As String, sAttrs As String, sBase As String
Dim ParamNames() As String, ParamTypes() As String
Dim MemberType As String, MemberHelpString As String, RetType As String
Dim ParamOptional() As String, ParamDefValue() As String, bEventInterface As Boolean
Dim sDecl As String, sQuery As String, sOldCode As String
Dim i As Long, j As Long
Dim arrGeneratedAttrs

On Error GoTo er
WriteTLBdata2XMLfile = True
If mvarXMLFile = "" Then
  ' Err.Raise 1000, , "Set XMLFile property first"
  Call CreateDefaultFilename("XMLDescription")
  mvarXMLFile = mvarOutputFiles("XMLDescription")
End If
m_oldDom.async = False
m_dom.async = False
m_dom.loadXML ""

sXML = BaseDir & mvarXMLFile
'read existing descriptions and other added information
bExisting = m_fso.FileExists(sXML)
If bExisting Then bExisting = (m_fso.GetFile(sXML).Size > 0)
If bExisting Then
  ' backup old XML
  sXMLCopy = Left(sXML, Len(sXML) - 4) & "_copy.xml"
  m_fso.CopyFile sXML, sXMLCopy, True
  m_oldDom.Load sXML
  Set nDeOld = m_oldDom.documentElement
  If nDeOld Is Nothing Then
    MsgBox sXML & " file is not well formed, aborting"
    WriteTLBdata2XMLfile = False
    Exit Function
  Else
   bExisting = True
  End If
End If
m_templateDom.Load App.Path & "\TemplateOfTypeLibInfo.xml"

If mvarEncoding <> "" Then
  Set pi = m_dom.createProcessingInstruction("xml", _
    "version='1.0' encoding='" & mvarEncoding & "'")
  m_dom.appendChild pi
End If

Set nDeT = m_templateDom.documentElement
Set nDe = nDeT.cloneNode(True)

With m_tli
Call nDe.setAttribute("File", .ContainingFile)
Call nDe.setAttribute("HelpString", .HelpString)
Call nDe.setAttribute("Version", .MajorVersion & "." & .MinorVersion)
Call nDe.setAttribute("HelpFile", .HelpFile)
Call nDe.setAttribute("GUID", .Guid)

' .SearchDefault =
Debug.Print "  ---- COCLASSES ----"
Set nCoClasses = nDe.selectSingleNode("CoClasses")
Set nCoClassT = nCoClasses.removeChild(nCoClasses.firstChild) ' first child is template
' .GetTypes(, tliStClasses, True)
For Each cofo In .CoClasses ' -------------------- loop for CoClasses
  ' list coclasses
  Debug.Print cofo.Name
  Set nItem = nCoClassT.cloneNode(True)
  Call nItem.setAttribute("Name", cofo.Name)
  Call nItem.setAttribute("HelpString", cofo.HelpString)
  sPathCoclass = "/TypeLibInfo/CoClasses/CoClass[@Name='" & cofo.Name & "']"
  If bExisting Then
    sQuery = sPathCoclass & "/CoClassDescription"
    Set nDescOld = nDeOld.selectSingleNode(sQuery)
    Set nDesc = nItem.selectSingleNode("CoClassDescription")
    If Not nDescOld Is Nothing Then nDesc.Text = nDescOld.Text
  End If
  Call nCoClasses.appendChild(nItem)
  ' list interfaces
  Set nInterfaces = nItem.selectSingleNode("Interfaces")
  Set nInterfaceT = nInterfaces.removeChild(nInterfaces.firstChild) ' first child is template
  For Each ifo In cofo.Interfaces ' -------------------- loop for Interfaces
    Set nItem = nInterfaceT.cloneNode(True)
    s = ifo.Name ' interface name
    Call nItem.setAttribute("Name", ifo.Name)
    Call nItem.setAttribute("HelpString", ifo.HelpString)
    sPathInterface = sPathCoclass & "/Interfaces" & _
      "/Interface[@Name='" & ifo.Name & "']"
    If bExisting Then
      sQuery = sPathInterface & "/InterfaceDescription"
      Set nDescOld = nDeOld.selectSingleNode(sQuery)
      Set nDesc = nItem.selectSingleNode("InterfaceDescription")
      If Not nDescOld Is Nothing Then nDesc.Text = nDescOld.Text
    End If
    sAttrs = ""
    For i = 1 To ifo.AttributeStrings(AttrArray)
      If i > 1 Then sAttrs = sAttrs & ","
      sAttrs = sAttrs & AttrArray(i)
    Next i
    If Len(sAttrs) > 0 Then
      s = s & " Attributes=" & sAttrs
      Call nItem.setAttribute("Attributes", sAttrs)
    End If
    Set ivfo = ifo.VTableInterface
    If Not ivfo Is Nothing Then
      Set Bases = ivfo.ImpliedInterfaces
      sBase = ""
      For Each ibasefo In Bases
        sBase = sBase & ibasefo.Name & ","
      Next
      sBase = RemoveLastChar(sBase)
      s = s & " Base Interfaces=" & sBase
      Call nItem.setAttribute("BaseInterfaces", sBase)
    End If ' Not ivfo Is Nothing
    Debug.Print s
    Call nInterfaces.appendChild(nItem)
    ' list Members
    Set nMembers = nItem.selectSingleNode("Members")
    Set nMemberT = nMembers.removeChild(nMembers.firstChild) ' first child is template
    ' For Each mi In ifo.Members -> not used, produces 2 members for each property (get/let)
    sdata = BuildSearchData(ifo.TypeInfoNumber, tliStClasses, .LibNum, True) ' helper function from Microsoft
    bEventInterface = (InStr(1, sAttrs, "source") > 0)
    Call .SetMemberFilters( _
      FUNCFLAG_FHIDDEN Or FUNCFLAG_FRESTRICTED Or FUNCFLAG_FNONBROWSABLE, _
      VARFLAG_FHIDDEN Or VARFLAG_FRESTRICTED Or VARFLAG_FNONBROWSABLE) ' this does not work :(
    For Each SI In ifo.Members.GetFilteredMembers(False) '  .GetMembers(sdata, True) ' ------------------ loop for Members
      'PrototypeMember(m_TLInf,List1.ItemData(List1.ListIndex),InvKinds, , .[_Default])
      InvKinds = IIf(bEventInterface, INVOKE_EVENTFUNC, SI.InvokeKinds)
      sDecl = PrototypeMember(ParamNames, ParamTypes, ParamOptional, ParamDefValue, _
         MemberType, MemberHelpString, RetType, m_tli, sdata, InvKinds, SI.MemberId, SI.Name)
      Set nItem = nMemberT.cloneNode(True)
      Call nItem.setAttribute("Name", SI.Name)
      arrGeneratedAttrs = Array( _
       "HelpString", "MemberType", "MemberTypeShort", "ReturnType", "Declaration")
      ' append generated attributes next
      Call nItem.setAttribute(arrGeneratedAttrs(0), MemberHelpString)
      Call nItem.setAttribute(arrGeneratedAttrs(1), InvokeInfo(InvKinds))
      Call nItem.setAttribute(arrGeneratedAttrs(2), InvokeInfoShort(InvKinds))
      Call nItem.setAttribute(arrGeneratedAttrs(3), RetType)
      Call nItem.setAttribute(arrGeneratedAttrs(4), sDecl)
      sPathMember = sPathInterface & "/Members/Member[@Name='" & SI.Name & "']"
      If bExisting Then
        ' copy Member description from existing xml
        sQuery = sPathMember & "/MemberDescription"
        Set nDescOld = nDeOld.selectSingleNode(sQuery)
        Set nDesc = nItem.selectSingleNode("MemberDescription")
        If Not nDescOld Is Nothing Then
          ' denote paragraph changes with <br/> tags in the text
          ' CDATA sections convert < to &lt;
          ' Call nDesc.appendChild(m_dom.createCDATASection(nDescOld.Text))
          ' br tag is used as Carriage Return in the method description, so we want
          ' to copy the full subnode, not only the text.
          Call nItem.removeChild(nDesc)
          Call nItem.appendChild(nDescOld)
        End If
        ' copy return-value description from existing xml
        sQuery = sPathMember & "/ReturnValueDescription"
        Set nRetDescOld = nDeOld.selectSingleNode(sQuery)
        Set nRetDesc = nItem.selectSingleNode("ReturnValueDescription")
        If Not nRetDescOld Is Nothing Then
          Call nItem.removeChild(nRetDesc)
          Call nItem.appendChild(nRetDescOld)
        End If
        ' copy example code from existing xml
        sQuery = sPathMember & "/ExampleCode"
        Set nExampleOld = nDeOld.selectSingleNode(sQuery)
        Set nExample = nItem.selectSingleNode("ExampleCode")
        If Not nExampleOld Is Nothing Then
          sOldCode = nExampleOld.Text
          ' nDesc.Text = nDescOld.Text
          ' code may contain illegal characters like '>'
          Call nExample.appendChild(m_dom.createCDATASection(nExampleOld.Text))
        End If
        ' copy related Members from existing xml <SeeAlso><Related>
        sQuery = sPathMember & "/SeeAlso"
        Set nSeeAlsoOld = nDeOld.selectSingleNode(sQuery)
        Set nSeeAlso = nItem.selectSingleNode("SeeAlso")
        If Not nSeeAlsoOld Is Nothing Then
          If Not nSeeAlsoOld.firstChild Is Nothing Then ' if any <Related> node exists
            Call nItem.removeChild(nSeeAlso)
            Call nItem.appendChild(nSeeAlsoOld)
          Else
            Call nSeeAlso.removeChild(nSeeAlso.firstChild)
          End If
        Else
          Call nSeeAlso.removeChild(nSeeAlso.firstChild)
        End If
        Set nItemOld = nDeOld.selectSingleNode(sPathMember)
       ' copy existing attributes to Member (e.g. categoryID,FrequenceOfUseID)
        If Not nItemOld Is Nothing Then
          For Each nMemberAttrOld In nItemOld.Attributes
            ' replace existing attribute with old only if the attribute is not
            ' automatically generated (it is written by the user)
            If FindStringInArray(nMemberAttrOld.baseName, arrGeneratedAttrs) < 0 Then
              Call nItem.setAttribute(nMemberAttrOld.baseName, nMemberAttrOld.Text)
            End If
          Next
        End If
      End If ' bExisting
      Call nMembers.appendChild(nItem)
      ' list parameters
      Set nParameters = nItem.selectSingleNode("Parameters")
      Set nParameterT = nParameters.removeChild(nParameters.firstChild) ' first child is template
      For j = 1 To UBound(ParamNames)  ' --------------------- loop for Parameters
         Set nItem = nParameterT.cloneNode(True)
         Call nItem.setAttribute("Name", ParamNames(j))
         Call nItem.setAttribute("Type", ParamTypes(j))
         Call nItem.setAttribute("Optional", ParamOptional(j))
         Call nItem.setAttribute("DefValue", ParamDefValue(j))
         Call nParameters.appendChild(nItem)
         ' copy old parameter descriptions
         If bExisting Then
           sPathParameter = sPathMember & "/Parameters/Parameter[@Name='" & ParamNames(j) & "']"
           sQuery = sPathParameter & "/ParameterDescription"
           Set nParamDescOld = nDeOld.selectSingleNode(sQuery)
           Set nParamDesc = nItem.selectSingleNode("ParameterDescription")
           If Not nParamDescOld Is Nothing Then
             nParamDesc.Text = nParamDescOld.Text
           End If
         End If ' bExisting
      Next j ' parameter
    Next ' members
  Next ' interface
Next ' coclass
' list enumerations
Set nEnumerations = nDe.selectSingleNode("Enumerations")
Set nEnumerationT = nEnumerations.removeChild(nEnumerations.firstChild) ' first child is template
For Each confo In .Constants ' --------------------- loop for Enumerations
  If confo.TypeKind = TKIND_ENUM Then ' TKIND_MODULE left as exercise for the reader !!
    Debug.Print confo.Name
    Set nItem = nEnumerationT.cloneNode(True)
    Call nItem.setAttribute("Name", confo.Name)
      If bExisting Then
        sQuery = "/TypeLibInfo/Enumerations/Enumeration[@Name='" & confo.Name & "']/EnumerationDescription"
        Set nDescOld = nDeOld.selectSingleNode(sQuery)
        Set nDesc = nItem.selectSingleNode("EnumerationDescription")
        If Not nDescOld Is Nothing Then
           Call nDesc.appendChild(m_dom.createCDATASection(nDescOld.Text))
        End If
      End If
    Call nEnumerations.appendChild(nItem)
    ' list enum members
    Set nEnumMembers = nItem.selectSingleNode("EnumMembers")
    Set nEnumMemberT = nEnumMembers.removeChild(nEnumMembers.firstChild) ' first child is template
    For Each MI In confo.Members
      Set nItem = nEnumMemberT.cloneNode(True)
      Call nItem.setAttribute("Name", MI.Name)
      Call nItem.setAttribute("Value", MI.Value)
      Call nEnumMembers.appendChild(nItem)
    Next ' member
  End If
Next ' constant
End With

m_dom.appendChild nDe
m_dom.Save sXML
Exit Function
er:
 MsgBox Err.Description
 WriteTLBdata2XMLfile = False
End Function
Private Function CreateDefaultFilename(ByVal key As String) As Boolean
 Dim sBaseFile As String, sItem As String
 sItem = mvarOutputFiles.Item(key)
 If Trim(sItem) = "" Then
   sBaseFile = GetBaseFile(TypeLibraryFile)
   'e.g. base + .xml
   Call mvarOutputFiles.Remove(key)
   Call mvarOutputFiles.Add(sBaseFile & mvarOutputFileTypes.Item(key), key)
   CreateDefaultFilename = True
 Else
   CreateDefaultFilename = False
 End If
End Function

' create HTML files for coclasses, interfaces, methods and enumerations
' TODO --------------- modify code if you want to change the files created
Public Function CreateAllFiles() As Boolean
' Content file related vars
Dim sXMLFile As String, sHTML As String, sTemp As String, pos As Long
Dim sXSLFile As String, sHHPFile As String, sHHCFile As String, sHHKFile As String
Dim sCHMFile As String, sScriptsFile As String, sStylesFile As String
Dim sGroup, sPath1, sPath2, sPath3, sFullPath
Dim sDirClass As String, sDirInter As String, sFilename As String, sName As String
Dim xslDoc As New FreeThreadedDOMDocument30
Dim xslTempl As New XSLTemplate30
Dim xslProcessor As IXSLProcessor
Dim oClasses, oInterfaces, oMembers, oEnums
Dim nCoClass As IXMLDOMElement
Dim nInterface As IXMLDOMElement
Dim nMember As IXMLDOMElement
Dim nEnumeration As IXMLDOMElement
Dim nEnum As IXMLDOMElement
Dim Selection As IXMLDOMSelection
Dim sOverWrite As String
Dim bForceCopyFile As Boolean
' load XML description file
CreateAllFiles = True

On Error GoTo er
m_dom.async = False
sXMLFile = BaseDir & mvarXMLFile
m_dom.Load sXMLFile ' m_dom contains full XML file
' load XSL template for HTML files
' Important: overwrite existing file if the user left the field blank
bForceCopyFile = CreateDefaultFilename("XSLFilesTemplate")
sXSLFile = BaseDir & mvarOutputFiles.Item("XSLFilesTemplate")
If Not m_fso.FileExists(sXSLFile) Or bForceCopyFile Then
  m_fso.CopyFile App.Path & "\TemplateOfTLBParts.XSL", sXSLFile, True
End If
sScriptsFile = BaseDir & "scripts.xsl"
If Not m_fso.FileExists(sScriptsFile) Then
  m_fso.CopyFile App.Path & "\scripts.xsl", sScriptsFile, True
End If
sStylesFile = BaseDir & "ie4.css"
If Not m_fso.FileExists(sStylesFile) Then
  m_fso.CopyFile App.Path & "\ie4.css", sStylesFile, True
End If
' create target Help Project file if not exists
bForceCopyFile = CreateDefaultFilename("HelpProject")
sHHPFile = BaseDir & mvarOutputFiles.Item("HelpProject")
If Not m_fso.FileExists(sHHPFile) Or bForceCopyFile Then
  m_fso.CopyFile App.Path & "\Template.hhp", sHHPFile, True
End If
' DO NOT create target Help Content file if not exists
'bForceCopyFile = CreateDefaultFilename("HelpContent")
' DO NOT create target Help Index file if not exists
'bForceCopyFile = CreateDefaultFilename("HelpIndex")
' write settings in the Help Project file
' put title
sTemp = mvarOutputFiles.Item("HelpProject")
pos = InStr(1, sTemp, ".")
If pos > 1 Then sTemp = Left(sTemp, pos - 1)
Call WritePrivateProfileString("OPTIONS", "Title", sTemp, sHHPFile)

Call CreateDefaultFilename("HelpCompiled") ' creates the name if it not exists !
sTemp = mvarOutputFiles.Item("HelpCompiled")
Call WritePrivateProfileString("OPTIONS", "Compiled file", sTemp, sHHPFile)

Call CreateDefaultFilename("HelpContent") ' creates the name if it not exists !
sTemp = mvarOutputFiles.Item("HelpContent")
Call WritePrivateProfileString("OPTIONS", "Contents file", sTemp, sHHPFile)

Call CreateDefaultFilename("HelpIndex") ' creates the name if it not exists !
sTemp = mvarOutputFiles.Item("HelpIndex")
Call WritePrivateProfileString("OPTIONS", "Index file", sTemp, sHHPFile)
' load stylesheet template
xslDoc.async = False
xslDoc.Load sXSLFile
' create XSL processor
Set xslTempl.stylesheet = xslDoc
Set xslProcessor = xslTempl.createProcessor
' set transformation parameters
xslProcessor.input = m_dom
' create files with the following structure
' Enum_XX.htm
' <DIR> Coclass
'   CoClass_XX.html,...
'   <DIR> Interface
'     Interface_XX.html
'     Interface_Members.html
'     Interface_MembersByCategory.html
'     Interface_MembersByUse.html
'     Member_XX.html
  sOverWrite = IIf(Overwrite = True, "yes", "no")
  Call xslProcessor.addParameter("ModuleName", sModuleName)
  Call xslProcessor.addParameter("BaseDir", BaseDir)
  Call xslProcessor.addParameter("HHP_file", mvarOutputFiles.Item("HelpProject"))
  Call xslProcessor.addParameter("HHC_file", mvarOutputFiles.Item("HelpContent"))
  Call xslProcessor.addParameter("HHK_file", mvarOutputFiles.Item("HelpIndex"))
  Call xslProcessor.addParameter("OverWrite", sOverWrite)
  Call xslProcessor.addParameter("CompanyLogo", CompanyLogo)
  Call xslProcessor.addParameter("CompanyHref", CompanyHref)
    
  xslProcessor.Transform
  Debug.Print xslProcessor.output
Exit Function
 ' -------------------- rest of the routine is not used now ----------------------
 ' this code transformed each part of the XML (interfaces,Members etc.) and saved the result
 ' i use msxml:script code now to do it
 ' this has the advantage that one need only to modify the XSL, not both the XSL and VB code
Set oClasses = m_dom.documentElement.selectNodes("/TypeLibInfo/CoClasses/CoClass")
For Each nCoClass In oClasses
   sName = nCoClass.getAttribute("Name")
   sDirClass = BaseDir & sName
   If Not m_fso.FolderExists(sDirClass) Then m_fso.CreateFolder sDirClass
   sFilename = sDirClass & "\" & "CoClass_" & sName & ".html"
   Call GenerateFromTemplate(xslProcessor, sFilename, nCoClass)
   Set oInterfaces = nCoClass.selectNodes("Interfaces/Interface[@Name='IManagerDlg']")
   For Each nInterface In oInterfaces
      sName = nInterface.getAttribute("Name")
      sDirInter = sDirClass & "\" & sName
      If Not m_fso.FolderExists(sDirInter) Then m_fso.CreateFolder sDirInter
      sFilename = sDirInter & "\" & "Interface_" & sName & ".html"
      Call GenerateFromTemplate(xslProcessor, sFilename, nInterface)
      sFilename = sDirInter & "\" & "Interface_" & sName & "_Members.html"
      Call GenerateFromTemplate(xslProcessor, sFilename, nInterface, "ListMembers")
      Set oMembers = nInterface.selectNodes("Members/Member")
       For Each nMember In oMembers
        sName = nMember.getAttribute("Name")
        sFilename = sDirInter & "\" & sName & ".html"
        Call GenerateFromTemplate(xslProcessor, sFilename, nMember)
       Next ' Member
    Next ' interface
Next ' class

Set oEnums = m_dom.documentElement.selectNodes("/TypeLibInfo/Enumerations/Enumeration")
For Each nEnum In oEnums
Next
' sHTML = m_dom.transformNode(xslDoc.documentElement)
' todo
Exit Function
er:
 MsgBox Err.Description
End Function
Sub GenerateFromTemplate(ByVal xslProcessor As IXSLProcessor, ByVal sFilename As String, _
  ByVal pNode As IXMLDOMNode, Optional ByVal sParam As String = "")

  Dim fOut As TextStream
  Set fOut = m_fso.OpenTextFile(sFilename, ForWriting, True)
  Call xslProcessor.addParameter("TargetNode", pNode)
  Call xslProcessor.addParameter("Param", sParam)
  xslProcessor.Transform
  fOut.Write xslProcessor.output
  fOut.Close
  
End Sub
Public Function RemoveLastChar(ByVal sStr As String) As String
RemoveLastChar = Left(sStr, Len(sStr) - 1)
End Function

Public Property Let TypeLibraryFile(ByVal vData As String)
 On Error Resume Next
 sTypeLibraryFile = vData
 sModuleName = GetBaseFile(vData)
 m_tli.ContainingFile = vData
 If Err.Number = tliErrCantLoadLibrary Then
   MsgBox "The file you selected does not contain valid type library information."
 End If
End Property

Public Property Get TypeLibraryFile() As String
  TypeLibraryFile = m_tli.ContainingFile
End Property



