VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmTypeLibraryExplorer 
   Caption         =   "Type Library Explorer"
   ClientHeight    =   8655
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   8790
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmTypeLibraryExplorer.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   8655
   ScaleWidth      =   8790
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame Frame1 
      Caption         =   "Type Library Information"
      Height          =   2295
      Left            =   240
      TabIndex        =   0
      Top             =   120
      Width           =   8295
      Begin MSComctlLib.ListView lvwLibraryInfo 
         Height          =   1695
         Left            =   240
         TabIndex        =   8
         Top             =   360
         Width           =   7815
         _ExtentX        =   13785
         _ExtentY        =   2990
         View            =   3
         LabelEdit       =   1
         LabelWrap       =   -1  'True
         HideSelection   =   0   'False
         HideColumnHeaders=   -1  'True
         FullRowSelect   =   -1  'True
         _Version        =   393217
         ForeColor       =   -2147483640
         BackColor       =   -2147483643
         BorderStyle     =   1
         Appearance      =   1
         NumItems        =   2
         BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
            Text            =   "Property"
            Object.Width           =   2540
         EndProperty
         BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
            SubItemIndex    =   1
            Text            =   "Value"
            Object.Width           =   2540
         EndProperty
      End
   End
   Begin MSComDlg.CommonDialog cdlTypeLibrary 
      Left            =   7920
      Top             =   5880
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
   End
   Begin VB.Frame Frame2 
      Caption         =   "Entity Documentation"
      Height          =   2775
      Left            =   240
      TabIndex        =   5
      Top             =   5640
      Width           =   8295
      Begin VB.TextBox txtEntityPrototype 
         BackColor       =   &H8000000F&
         BorderStyle     =   0  'None
         Height          =   975
         Left            =   360
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   9
         Top             =   1440
         Width           =   7695
      End
      Begin VB.Label Label3 
         AutoSize        =   -1  'True
         BackStyle       =   0  'Transparent
         Caption         =   "Entity Prototype:"
         Height          =   195
         Left            =   240
         TabIndex        =   11
         Top             =   1200
         Width           =   1245
      End
      Begin VB.Label lblEntityName 
         AutoSize        =   -1  'True
         BackStyle       =   0  'Transparent
         Caption         =   "Entity Name"
         BeginProperty Font 
            Name            =   "Tahoma"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Left            =   240
         TabIndex        =   10
         Top             =   360
         Width           =   1020
      End
      Begin VB.Label lblMemberOf 
         BackStyle       =   0  'Transparent
         Caption         =   "MemberOf"
         Height          =   195
         Left            =   360
         TabIndex        =   7
         Top             =   600
         Width           =   7605
      End
      Begin VB.Label lblHelpText 
         BackStyle       =   0  'Transparent
         Caption         =   "HelpText"
         Height          =   315
         Left            =   360
         TabIndex        =   6
         Top             =   840
         Width           =   7605
      End
   End
   Begin VB.ListBox lstMembers 
      Height          =   2400
      Left            =   4560
      Sorted          =   -1  'True
      TabIndex        =   4
      Top             =   2880
      Width           =   3975
   End
   Begin VB.ListBox lstTypeInfos 
      Height          =   2400
      Left            =   240
      Sorted          =   -1  'True
      TabIndex        =   2
      Top             =   2880
      Width           =   3975
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Members:"
      Height          =   195
      Left            =   4560
      TabIndex        =   3
      Top             =   2640
      Width           =   705
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "TypeInfos:"
      Height          =   195
      Left            =   240
      TabIndex        =   1
      Top             =   2640
      Width           =   795
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open..."
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "frmTypeLibraryExplorer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public tliTypeLibInfo As TypeLibInfo

Public Function ProduceDefaultValue(DefVal As Variant, ByVal tliTypeInfo As TypeInfo) As String
'This helper function adapted from Microsoft documentation
Dim lngTrackVal As Long
Dim MI As MemberInfo
Dim tliTypeKinds As TypeKinds
    
If tliTypeInfo Is Nothing Then
    Select Case VarType(DefVal)
        Case vbString
            If Len(DefVal) Then
                ProduceDefaultValue = " = " & """" & DefVal & """"
            End If
        Case vbBoolean 'Always show for Boolean
            ProduceDefaultValue = " = " & DefVal
        Case vbDate
            If DefVal Then
                ProduceDefaultValue = " = " & "#" & DefVal & "#"
            End If
        Case Else 'Numeric Values
            If DefVal <> 0 Then
                ProduceDefaultValue = " = " & DefVal
            End If
    End Select
Else
    'Resolve constants to their enums
    tliTypeKinds = tliTypeInfo.TypeKind
    Do While tliTypeKinds = TKIND_ALIAS
        tliTypeKinds = TKIND_MAX
        On Error Resume Next
        Set tliTypeInfo = tliTypeInfo.ResolvedType
        If Err = 0 Then
            tliTypeKinds = tliTypeInfo.TypeKind
        End If
        On Error GoTo 0
    Loop
    If tliTypeInfo.TypeKind = TKIND_ENUM Then
        lngTrackVal = DefVal
        For Each MI In tliTypeInfo.Members
            If MI.Value = lngTrackVal Then
                ProduceDefaultValue = " = " & MI.Name
                Exit For
            End If
        Next
    End If
End If
End Function
Public Function GetSearchType(ByVal SearchData As Long) As TliSearchTypes
    'This helper function adapted from Microsoft documentation
    If SearchData And &H80000000 Then
        GetSearchType = ((SearchData And &H7FFFFFFF) \ &H1000000 And &H7F&) Or &H80
    Else
        GetSearchType = SearchData \ &H1000000 And &HFF&
    End If
End Function
Private Sub Form_Load()
    cdlTypeLibrary.DialogTitle = "Open Type Library"
    cdlTypeLibrary.InitDir = "d:\winnt\system32\"
    cdlTypeLibrary.Filter = "Type Libraries (*.tlb;*.olb;*.dll;*.ocx)|*.tlb;*.olb;*.dll;*.ocx|All Files (*.*)|*.*"
    Set tliTypeLibInfo = New TypeLibInfo
    tliTypeLibInfo.AppObjString = "<Global>"
    lvwLibraryInfo.ColumnHeaders(1).Width = lvwLibraryInfo.Width / 4 - 100
    lvwLibraryInfo.ColumnHeaders(2).Width = lvwLibraryInfo.Width * 3 / 4
    lblEntityName = ""
    lblMemberOf = ""
    lblHelpText = ""
    Label3.Visible = False
End Sub

Public Function PrototypeMember(ByVal SearchData As Long, _
    ByVal InvokeKinds As InvokeKinds, _
    Optional ByVal MemberName As String) As String
    'This helper function adapted from Microsoft documentation
    ' On Error Resume Next
    
    Dim tliParameterInfo As ParameterInfo
    Dim bFirstParameter As Boolean
    Dim bIsConstant As Boolean
    Dim bByVal As Boolean
    Dim strReturn As String
    Dim ConstVal As Variant
    Dim strTypeName As String
    Dim intVarTypeCur As Integer
    Dim bDefault As Boolean
    Dim bOptional As Boolean
    Dim bParamArray As Boolean
    Dim tliTypeInfo As TypeInfo
    Dim tliResolvedTypeInfo As TypeInfo
    Dim tliTypeKinds As TypeKinds
  
    With tliTypeLibInfo
    'First, determine the type of member we're dealing with
    bIsConstant = GetSearchType(SearchData) And tliStConstants
    With .GetMemberInfo(SearchData, InvokeKinds, , MemberName)
        If bIsConstant Then
            strReturn = "Const "
        ElseIf InvokeKinds = INVOKE_FUNC Or InvokeKinds = INVOKE_EVENTFUNC Then
            Select Case .ReturnType.VarType
                Case VT_VOID, VT_HRESULT
                    strReturn = "Sub "
                Case Else
                    strReturn = "Function "
            End Select
        Else
            strReturn = "Property "
        End If
    
        'Now add the name of the member
        strReturn = strReturn & .Name
    
        'Process the member's paramters
        With .Parameters
            If .Count Then ' ------------------------------------
                strReturn = strReturn & " ("
                bFirstParameter = True
                bParamArray = .OptionalCount = -1
                For Each tliParameterInfo In .Me
                    If Not bFirstParameter Then
                        strReturn = strReturn & ", "
                    End If
                    bFirstParameter = False
                    bDefault = tliParameterInfo.Default
                    bOptional = bDefault Or tliParameterInfo.Optional
                    If bOptional Then
                        If bParamArray Then
                            'This will be the only optional parameter
                            strReturn = strReturn & "[ParamArray "
                        Else
                            strReturn = strReturn & "["
                        End If
                    End If
                
                    With tliParameterInfo.VarTypeInfo
                        Set tliTypeInfo = Nothing
                        Set tliResolvedTypeInfo = Nothing
                        tliTypeKinds = TKIND_MAX
                        intVarTypeCur = .VarType ' var type
                        ' intVarTypeCur & ~(VT_ARRAY | VT_VECTOR)
                        If (intVarTypeCur And Not (VT_ARRAY Or VT_VECTOR)) = 0 Then
                            On Error Resume Next
                            Set tliTypeInfo = .TypeInfo ' type info
                            If Not tliTypeInfo Is Nothing Then
                                Set tliResolvedTypeInfo = tliTypeInfo
                                tliTypeKinds = tliResolvedTypeInfo.TypeKind
                                Do While tliTypeKinds = TKIND_ALIAS
                                    tliTypeKinds = TKIND_MAX
                                    Set tliResolvedTypeInfo = tliResolvedTypeInfo.ResolvedType
                                    If Err Then
                                        Err.Clear
                                    Else
                                        tliTypeKinds = tliResolvedTypeInfo.TypeKind
                                    End If
                                Loop
                            End If
                        
                            'Determine whether parameters are ByVal or ByRef
                            Select Case tliTypeKinds
                                Case TKIND_INTERFACE, TKIND_COCLASS, TKIND_DISPATCH
                                    bByVal = (.PointerLevel = 1)
                                Case TKIND_RECORD
                                    'Records not passed ByVal in VB
                                    bByVal = False
                                Case Else
                                    bByVal = (.PointerLevel = 0)
                            End Select
                        
                            'Indicate ByVal
                            If bByVal Then
                                strReturn = strReturn & "ByVal "
                            End If
                        
                            'Display the parameter name
                            strReturn = strReturn & tliParameterInfo.Name
                        
                            If intVarTypeCur And (VT_ARRAY Or VT_VECTOR) Then
                                strReturn = strReturn & "()"
                            End If
                            
                            If tliTypeInfo Is Nothing Then 'Information not available
                                strReturn = strReturn & " As ?"
                            Else
                                If .IsExternalType Then
                                    strReturn = strReturn & " As " & .TypeLibInfoExternal.Name & "." & tliTypeInfo.Name
                                Else
                                    strReturn = strReturn & " As " & tliTypeInfo.Name
                                End If
                            End If
                        
                            'Reset error handling
                            On Error GoTo 0
                        Else '(intVarTypeCur And Not (VT_ARRAY Or VT_VECTOR)) = 0 Then
                            If .PointerLevel = 0 Then
                                strReturn = strReturn & "ByVal "
                            End If
                                
                            strReturn = strReturn & tliParameterInfo.Name
                            If intVarTypeCur <> vbVariant Then
                                strTypeName = TypeName(.TypedVariant)
                                If intVarTypeCur And (VT_ARRAY Or VT_VECTOR) Then
                                    strReturn = strReturn & "() As " & Left$(strTypeName, Len(strTypeName) - 2)
                                Else
                                    strReturn = strReturn & " As " & strTypeName
                                End If
                            End If
                        End If
                            
                        If bOptional Then
                            If bDefault Then
                                strReturn = strReturn & ProduceDefaultValue(tliParameterInfo.DefaultValue, tliResolvedTypeInfo)
                                'strReturn = strReturn & " = " & tliParameterInfo.DefaultValue
                            End If
                            strReturn = strReturn & "]"
                        End If
                    End With
                Next
                strReturn = strReturn & ")"
            End If
        End With
    
        If bIsConstant Then
            ConstVal = .Value
            strReturn = strReturn & " = " & ConstVal
            Select Case VarType(ConstVal)
                Case vbInteger, vbLong
                    If ConstVal < 0 Or ConstVal > 15 Then
                        strReturn = strReturn & " (&H" & Hex$(ConstVal) & ")"
                    End If
            End Select
        Else
            With .ReturnType
                intVarTypeCur = .VarType
                If intVarTypeCur = 0 Or (intVarTypeCur And Not (VT_ARRAY Or VT_VECTOR)) = 0 Then
                    On Error Resume Next
                    If Not .TypeInfo Is Nothing Then
                        If Err Then 'Information not available
                            strReturn = strReturn & " As ?"
                        Else
                            If .IsExternalType Then
                                strReturn = strReturn & " As " & .TypeLibInfoExternal.Name & "." & .TypeInfo.Name
                            Else
                                strReturn = strReturn & " As " & .TypeInfo.Name
                            End If
                        End If
                    End If
                    
                    If intVarTypeCur And (VT_ARRAY Or VT_VECTOR) Then
                        strReturn = strReturn & "()"
                    End If
                    On Error GoTo 0
                Else
                    Select Case intVarTypeCur
                        Case VT_VARIANT, VT_VOID, VT_HRESULT
                        Case Else
                            strTypeName = TypeName(.TypedVariant)
                            If intVarTypeCur And (VT_ARRAY Or VT_VECTOR) Then
                                strReturn = strReturn & "() As " & Left$(strTypeName, Len(strTypeName) - 2)
                            Else
                                strReturn = strReturn & " As " & strTypeName
                            End If
                    End Select
                End If
            End With
        End If
        
        PrototypeMember = strReturn & vbCrLf
        lblMemberOf = "Member of " & tliTypeLibInfo.Name & "." & tliTypeLibInfo.GetTypeInfo(SearchData And &HFFFF&).Name
        lblHelpText = .HelpString
    End With
    End With
End Function

Private Sub lstMembers_Click()
    Dim tliInvokeKinds As InvokeKinds
    tliInvokeKinds = lstMembers.ItemData(lstMembers.ListIndex)
    lblEntityName = lstMembers.[_Default]
    txtEntityPrototype = PrototypeMember(lstTypeInfos.ItemData(lstTypeInfos.ListIndex), tliInvokeKinds, lstMembers.[_Default])
End Sub


Private Sub lstTypeInfos_Click()
    Dim tliTypeInfo As TypeInfo
    
    Set tliTypeInfo = tliTypeLibInfo.GetTypeInfo(lstTypeInfos.List(lstTypeInfos.ListIndex))
    lblEntityName = lstTypeInfos.[_Default]
    lblMemberOf = "Member of " & tliTypeInfo.Parent
    lblHelpText = tliTypeInfo.HelpString
    txtEntityPrototype = ""

    'Use the ItemData in lstTypeInfos to set the SearchData for lstMembers
    tliTypeLibInfo.GetMembersDirect _
     lstTypeInfos.ItemData(lstTypeInfos.ListIndex), lstMembers.hWnd, , tliIdtInvokeKinds ' PHILIP
End Sub

Private Sub mnuFileExit_Click()
    Unload Me
    Set frmTypeLibraryExplorer = Nothing
    End
End Sub

Private Sub mnuFileOpen_Click()
    On Error Resume Next
    cdlTypeLibrary.ShowOpen
    If Err.Number <> cdlCancel Then
        tliTypeLibInfo.ContainingFile = cdlTypeLibrary.FileName
        If Err.Number = tliErrCantLoadLibrary Then
            MsgBox "The file you selected does not contain valid type library information." & _
                   vbCrLf & "Try a file with the extension *.tlb.", vbCritical, "Invalid Type Library"
        Else
            Call ProcessTypeLibrary
        End If
    End If
End Sub

Public Sub ProcessTypeLibrary()
    frmTypeLibraryExplorer.Caption = "Type Library Explorer - " & tliTypeLibInfo.Name
    
    'Display general type library information
    lvwLibraryInfo.ListItems.Clear
    lvwLibraryInfo.ListItems.Add , "Name", "Name"
    lvwLibraryInfo.ListItems("Name").SubItems(1) = tliTypeLibInfo.Name
    
    lvwLibraryInfo.ListItems.Add , "File", "File"
    lvwLibraryInfo.ListItems("File").SubItems(1) = LCase(tliTypeLibInfo.ContainingFile)
    
    lvwLibraryInfo.ListItems.Add , "Description", "Description"
    lvwLibraryInfo.ListItems("Description").SubItems(1) = tliTypeLibInfo.HelpString
    
    lvwLibraryInfo.ListItems.Add , "Version", "Version"
    lvwLibraryInfo.ListItems("Version").SubItems(1) = tliTypeLibInfo.MajorVersion & "." & tliTypeLibInfo.MinorVersion
    
    lvwLibraryInfo.ListItems.Add , "HelpFile", "Help File"
    lvwLibraryInfo.ListItems("HelpFile").SubItems(1) = LCase(tliTypeLibInfo.HelpFile)

    lvwLibraryInfo.ListItems.Add , "System", "System"
    Select Case tliTypeLibInfo.SysKind
        Case SYS_MAC:
            lvwLibraryInfo.ListItems("System").SubItems(1) = "Macintosh"
        Case SYS_WIN16:
            lvwLibraryInfo.ListItems("System").SubItems(1) = "Win16"
        Case SYS_WIN32:
            lvwLibraryInfo.ListItems("System").SubItems(1) = "Win32"
    End Select
    
    lvwLibraryInfo.ListItems.Add , "Guid", "Guid"
    lvwLibraryInfo.ListItems("Guid").SubItems(1) = tliTypeLibInfo.Guid
    
    'Clear lists
    lstTypeInfos.Clear
    lstMembers.Clear
    
    'Display members for type library
    tliTypeLibInfo.GetTypesDirect lstTypeInfos.hWnd, , tliStAll
End Sub

Private Sub txtEntityPrototype_Change()
    Label3.Visible = txtEntityPrototype <> ""
End Sub
